<script setup lang="ts">
import { ref } from 'vue';

import { useVbenDrawer, useVbenForm } from '@vben/common-ui';

import { drawerFormSchema } from './connectInfo-data';

import {
  addConnectInfo,
  updateConnectInfo,
  getConnectInfoDetail,
} from '#/api/system/infoEntry/connectInfo/connectInfo';

const emit = defineEmits<{
  reload: [];
}>();

const [Form, formApi] = useVbenForm({
  showDefaultActions: false,
  schema: drawerFormSchema(),
});

const isUpdateRef = ref<boolean>(false);

const [Drawer, drawerApi] = useVbenDrawer({
  async onOpenChange(isOpen) {
    if (!isOpen) {
      return;
    }
    try {
      drawerApi.drawerLoading(true);
      const { id, isUpdate } = drawerApi.getData();
      isUpdateRef.value = isUpdate;
      if (isUpdate && id) {
        // 获取详情数据
        const response = await getConnectInfoDetail(id);
        await formApi.setValues(response);
      }
    } catch (error) {
      console.error('获取交接事项详情失败:', error);
    } finally {
      drawerApi.drawerLoading(false);
    }
  },

  async onConfirm() {
    try {
      this.confirmLoading = true;
      const { valid } = await formApi.validate();
      if (!valid) {
        return;
      }
      const data = await formApi.getValues();
      // 提交数据
      if (isUpdateRef.value) {
        await updateConnectInfo(data);
      } else {
        await addConnectInfo(data);
      }
      emit('reload');
      drawerApi.close();
    } catch (error) {
      console.error('保存交接事项信息失败:', error);
    } finally {
      this.confirmLoading = false;
    }
  },

  onClosed() {
    formApi.resetForm();
  },
});
</script>

<template>
  <Drawer :title="isUpdateRef ? '编辑交接事项' : '新增交接事项'">
    <Form />
  </Drawer>
</template>
